searchNodes=[{"doc":"Module exposing various utility functions for interacting with, and introspecting the state of EctoHooks.For more extensive usage instructions, please see associated documentation for EctoHooks.Repo.","ref":"EctoHooks.html","title":"EctoHooks","type":"behaviour"},{"doc":"Alternative interface for initializing EctoHooks when use-ed in a module as follows:def MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres use EctoHooks endPlease see EctoHooks.Repo for more information about EctoHooks usage, examples, and considerations.","ref":"EctoHooks.html#__using__/1","title":"EctoHooks.__using__/1","type":"macro"},{"doc":"","ref":"EctoHooks.html#c:after_delete/2","title":"EctoHooks.after_delete/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_get/2","title":"EctoHooks.after_get/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_insert/2","title":"EctoHooks.after_insert/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_update/2","title":"EctoHooks.after_update/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_delete/1","title":"EctoHooks.before_delete/1","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_insert/1","title":"EctoHooks.before_insert/1","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_update/1","title":"EctoHooks.before_update/1","type":"callback"},{"doc":"Disables the next before_* or after_* hook from executing. This is automatically cleared after triggering any Ecto.Repo callback.","ref":"EctoHooks.html#disable_hooks/0","title":"EctoHooks.disable_hooks/0","type":"function"},{"doc":"Enables the next before_* or after_* hook to execute from within the context of an already running hook.As a mitigation for infinitely looping hooks caused by hooks triggering other hooks, hooks will not run while inside the stacktrace of another hook.Calling this function opts out of this mitigation for the next hook being executed.","ref":"EctoHooks.html#enable_hooks/0","title":"EctoHooks.enable_hooks/0","type":"function"},{"doc":"Returns a boolean indicating if any before_* or after_* hooks are allowed to execute in the current process.Note that calls to Ecto.Repo callbacks may reset or change the state of this flag, and that this function is primarily exposed for introspection or debugging purposes.","ref":"EctoHooks.html#hooks_enabled?/0","title":"EctoHooks.hooks_enabled?/0","type":"function"},{"doc":"Utility function which returns the &quot;nesting&quot; of the current EctoHooks context.By default, every hook will &quot;acquire&quot; an EctoHook context and increment a ref count. These ref counts are automatically decremented once a hook finishes running.This is provided as a lower level alternative the enable_hooks/0, disable_hooks/0, and hooks_enabled?/0 functions.","ref":"EctoHooks.html#hooks_ref_count/0","title":"EctoHooks.hooks_ref_count/0","type":"function"},{"doc":"Utility function which returns true if currently executing inside the context of an Ecto Hook.","ref":"EctoHooks.html#in_hook?/0","title":"EctoHooks.in_hook?/0","type":"function"},{"doc":"Defines the struct which is given as the 2nd argument to any after_* hooks.Contains metadata which may be useful for introspecting or otherwise conditionally running hooks only when certain conditions are met.The following information is present in an EctoHooks.Delta:The Ecto.Repo callback that triggered the hookThe name of the current hook (useful if delegating to private functions in your schema)The Ecto.Queryable passed into the triggering Ecto.Repo callback if anyThe Ecto.Changeset passed into the triggering Ecto.Repo callback if any","ref":"EctoHooks.Delta.html","title":"EctoHooks.Delta","type":"module"},{"doc":"","ref":"EctoHooks.Delta.html#new!/3","title":"EctoHooks.Delta.new!/3","type":"function"},{"doc":"","ref":"EctoHooks.Delta.html#t:hook/0","title":"EctoHooks.Delta.hook/0","type":"type"},{"doc":"","ref":"EctoHooks.Delta.html#t:repo_callback/0","title":"EctoHooks.Delta.repo_callback/0","type":"type"},{"doc":"","ref":"EctoHooks.Delta.html#t:t/0","title":"EctoHooks.Delta.t/0","type":"type"},{"doc":"This module is intended to replace any usage of use Ecto.Repo. When this is done, any of the following Ecto.Repo callbacks will execute any defined before_* or after_* hooks in your Ecto schemas before returning.Setup and initializationSimply use this module wherever you would use Ecto.Schema. Any provided options are currently forwarded to use Ecto.Repo. In the future, EctoHooks may provide additional functionality based on given options.Example Usage:defmodule MyApp.Repo do use EctoHooks.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres end def MyApp.User do use Ecto.Schema require Logger schema &quot;users&quot; do field :first_name, :string field :last_name, :string field :full_name, :string, virtual: true end def before_insert(changeset) do Logger.warning(&quot;inserted a new user...&quot;) changeset end def after_get(%__MODULE__{} = user, %EctoHooks.Delta{}) do %__MODULE__{user | full_name: user.first_name &lt;&gt; &quot; &quot; &lt;&gt; user.last_name} end endUsageAfter HooksOnce initialized, the following Ecto.Repo callbacks will trigger the listed after_* hooks.Executes after_get/2 if defined in schema:all/2get/3get!/3get_by/3get_by!/3one/2one!/2Executes after_delete/2 if defined in schema:delete/2delete!/2Executes after_insert/2 if defined in schema:insert/2insert!/2Executes after_update/2 if defined in schema:update/2update!/2Executes after_insert/2 or to after_update/2 if defined in schema:insert_or_update/2insert_or_update!/2Please note that the result of an after_* hook is the result which is intended to be returned by any of the above Ecto.Repo callbacks. All after_* hooks are expected to abide by the following typespec:@spec after_*(schema_struct :: MyApp.User.t(), delta :: EctoHooks.Delta.t()) :: MyApp.User.t()And any Ecto.Repo callback which expects to return {:ok, result} over result will do so automatically.Take care to not break expected Ecto.Repo callback semantics as bugs resulting from these can prove difficult to diagnose and track down. As a rule of thumb, you should always aim to return the same type of argument passed into your defined hooks.Before HooksOnce initialized, the following Ecto.Repo callbacks will trigger the listed before_* hooks.Executes before_delete/1 if defined in schema:delete/2delete!/2Executes before_insert/1 if defined in schema:insert/2insert!/2Executes before_update/1 if defined in schema:update/2update!/2Executes before_insert/1 or to before_update/1 if defined in schema:insert_or_update/2insert_or_update!/2Please note that the result of an before_* hook is usually the Ecto.Queryable which is passed as the first parameter to any of the above Ecto.Repo callbacks. All before_* hooks are expected to abide by the following typespec:@spec before_*(queryable :: Ecto.Queryable.t()) :: Ecto.Queryable.t()ConsiderationsEctoHooks was initially designed to help with centralizing and de-duplicating logic to resolve virtual fields when working with Ecto schemas. However, since EctoHooks allows you to call arbitrary functions in response to Ecto.Repo callbacks, it can be used for much more.All defined hooks are also executed synchronously, immediately before or after calling your Ecto.Repo callback. To try and mitigate the potential for infinite loops caused by hooks triggering other hooks, by default, EctoHooks will only trigger a hook if a parent function in the current process stacktrace is not another hook.As a result, one should take great care when spawning processes which may result in calling Ecto.Repo callbacks, as there is currently no mitigation for infinite loops provided.If you wish to opt in, opt out, or introspect the state of these mitigations, please see the documentation for the following functions: EctoHooks.enable_hooks/0, EctoHooks.disable_hooks/0, EctoHooks.hooks_enabled?/0 and EctoHooks.in_hook?/0.This is a very powerful tool, and admittedly quite hidden and hard to track down. Trying to avoid adding too much business logic in your EctoHooks is wise for both performance reasons (as hooks are executed on every request), and maintainability reasons.","ref":"EctoHooks.Repo.html","title":"EctoHooks.Repo","type":"module"},{"doc":"Enables EctoHooks integration in your Ecto.Repo module when use-ed.","ref":"EctoHooks.Repo.html#__using__/1","title":"EctoHooks.Repo.__using__/1","type":"macro"}]